/*
 * Product Ordering
 *
 * **TMF API Reference : TMF 622 - Product Ordering Management**  **Release : 19.0 - June 2019**  The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.  The product order references the product offer and identifies any specific requests made by the customer.  **Product Order resource** A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.  Product Order API performs the following operations on product order :     -Retrieval of a product order or a collection of product orders depending on filter criteria     -Partial update of a product order (including updating rules)    -Creation of a product order (including default values and creation rules)    -Deletion of product order (for administration purposes)     -Notification of events on product order.  **cancelProductOrder resource** This resource is used to request a product order cancellation. Product Order API performs the following operations on product order :     -Retrieval of a cancel product order or a collection of cancel product orders     -Creation of a cancel product order     -Notification of events on cancel product order.   Copyright © TM Forum 2019. All Rights Reserved   
 *
 * API version: 4.0.0
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package openapi

import (
	"encoding/json"
)

// PriceAlteration Is an amount, usually of money, that modifies the price charged for an order item.
type PriceAlteration struct {
	// Duration during which the alteration applies on the order item price (for instance 2 months free of charge for the recurring charge)
	ApplicationDuration *int32 `json:"applicationDuration,omitempty"`
	// A narrative that explains in detail the semantics of this order item price alteration
	Description *string `json:"description,omitempty"`
	// Name of the order item price alteration
	Name *string `json:"name,omitempty"`
	// A category that describes the price such as recurring, one time and usage.
	PriceType string `json:"priceType"`
	// Priority level for applying this alteration among all the defined alterations on the order item price
	Priority *int32 `json:"priority,omitempty"`
	// Could be month, week...
	RecurringChargePeriod *string `json:"recurringChargePeriod,omitempty"`
	// Could be minutes, GB...
	UnitOfMeasure *string `json:"unitOfMeasure,omitempty"`
	Price Price `json:"price"`
	ProductOfferingPrice *ProductOfferingPriceRef `json:"productOfferingPrice,omitempty"`
	// When sub-classing, this defines the super-class
	BaseType *string `json:"@baseType,omitempty"`
	// A URI to a JSON-Schema file that defines additional attributes and relationships
	SchemaLocation *string `json:"@schemaLocation,omitempty"`
	// When sub-classing, this defines the sub-class entity name
	Type *string `json:"@type,omitempty"`
}

// NewPriceAlteration instantiates a new PriceAlteration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPriceAlteration(priceType string, price Price, ) *PriceAlteration {
	this := PriceAlteration{}
	this.PriceType = priceType
	this.Price = price
	return &this
}

// NewPriceAlterationWithDefaults instantiates a new PriceAlteration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPriceAlterationWithDefaults() *PriceAlteration {
	this := PriceAlteration{}
	return &this
}

// GetApplicationDuration returns the ApplicationDuration field value if set, zero value otherwise.
func (o *PriceAlteration) GetApplicationDuration() int32 {
	if o == nil || o.ApplicationDuration == nil {
		var ret int32
		return ret
	}
	return *o.ApplicationDuration
}

// GetApplicationDurationOk returns a tuple with the ApplicationDuration field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetApplicationDurationOk() (*int32, bool) {
	if o == nil || o.ApplicationDuration == nil {
		return nil, false
	}
	return o.ApplicationDuration, true
}

// HasApplicationDuration returns a boolean if a field has been set.
func (o *PriceAlteration) HasApplicationDuration() bool {
	if o != nil && o.ApplicationDuration != nil {
		return true
	}

	return false
}

// SetApplicationDuration gets a reference to the given int32 and assigns it to the ApplicationDuration field.
func (o *PriceAlteration) SetApplicationDuration(v int32) {
	o.ApplicationDuration = &v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *PriceAlteration) GetDescription() string {
	if o == nil || o.Description == nil {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetDescriptionOk() (*string, bool) {
	if o == nil || o.Description == nil {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *PriceAlteration) HasDescription() bool {
	if o != nil && o.Description != nil {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *PriceAlteration) SetDescription(v string) {
	o.Description = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *PriceAlteration) GetName() string {
	if o == nil || o.Name == nil {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetNameOk() (*string, bool) {
	if o == nil || o.Name == nil {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *PriceAlteration) HasName() bool {
	if o != nil && o.Name != nil {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *PriceAlteration) SetName(v string) {
	o.Name = &v
}

// GetPriceType returns the PriceType field value
func (o *PriceAlteration) GetPriceType() string {
	if o == nil  {
		var ret string
		return ret
	}

	return o.PriceType
}

// GetPriceTypeOk returns a tuple with the PriceType field value
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetPriceTypeOk() (*string, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.PriceType, true
}

// SetPriceType sets field value
func (o *PriceAlteration) SetPriceType(v string) {
	o.PriceType = v
}

// GetPriority returns the Priority field value if set, zero value otherwise.
func (o *PriceAlteration) GetPriority() int32 {
	if o == nil || o.Priority == nil {
		var ret int32
		return ret
	}
	return *o.Priority
}

// GetPriorityOk returns a tuple with the Priority field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetPriorityOk() (*int32, bool) {
	if o == nil || o.Priority == nil {
		return nil, false
	}
	return o.Priority, true
}

// HasPriority returns a boolean if a field has been set.
func (o *PriceAlteration) HasPriority() bool {
	if o != nil && o.Priority != nil {
		return true
	}

	return false
}

// SetPriority gets a reference to the given int32 and assigns it to the Priority field.
func (o *PriceAlteration) SetPriority(v int32) {
	o.Priority = &v
}

// GetRecurringChargePeriod returns the RecurringChargePeriod field value if set, zero value otherwise.
func (o *PriceAlteration) GetRecurringChargePeriod() string {
	if o == nil || o.RecurringChargePeriod == nil {
		var ret string
		return ret
	}
	return *o.RecurringChargePeriod
}

// GetRecurringChargePeriodOk returns a tuple with the RecurringChargePeriod field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetRecurringChargePeriodOk() (*string, bool) {
	if o == nil || o.RecurringChargePeriod == nil {
		return nil, false
	}
	return o.RecurringChargePeriod, true
}

// HasRecurringChargePeriod returns a boolean if a field has been set.
func (o *PriceAlteration) HasRecurringChargePeriod() bool {
	if o != nil && o.RecurringChargePeriod != nil {
		return true
	}

	return false
}

// SetRecurringChargePeriod gets a reference to the given string and assigns it to the RecurringChargePeriod field.
func (o *PriceAlteration) SetRecurringChargePeriod(v string) {
	o.RecurringChargePeriod = &v
}

// GetUnitOfMeasure returns the UnitOfMeasure field value if set, zero value otherwise.
func (o *PriceAlteration) GetUnitOfMeasure() string {
	if o == nil || o.UnitOfMeasure == nil {
		var ret string
		return ret
	}
	return *o.UnitOfMeasure
}

// GetUnitOfMeasureOk returns a tuple with the UnitOfMeasure field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetUnitOfMeasureOk() (*string, bool) {
	if o == nil || o.UnitOfMeasure == nil {
		return nil, false
	}
	return o.UnitOfMeasure, true
}

// HasUnitOfMeasure returns a boolean if a field has been set.
func (o *PriceAlteration) HasUnitOfMeasure() bool {
	if o != nil && o.UnitOfMeasure != nil {
		return true
	}

	return false
}

// SetUnitOfMeasure gets a reference to the given string and assigns it to the UnitOfMeasure field.
func (o *PriceAlteration) SetUnitOfMeasure(v string) {
	o.UnitOfMeasure = &v
}

// GetPrice returns the Price field value
func (o *PriceAlteration) GetPrice() Price {
	if o == nil  {
		var ret Price
		return ret
	}

	return o.Price
}

// GetPriceOk returns a tuple with the Price field value
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetPriceOk() (*Price, bool) {
	if o == nil  {
		return nil, false
	}
	return &o.Price, true
}

// SetPrice sets field value
func (o *PriceAlteration) SetPrice(v Price) {
	o.Price = v
}

// GetProductOfferingPrice returns the ProductOfferingPrice field value if set, zero value otherwise.
func (o *PriceAlteration) GetProductOfferingPrice() ProductOfferingPriceRef {
	if o == nil || o.ProductOfferingPrice == nil {
		var ret ProductOfferingPriceRef
		return ret
	}
	return *o.ProductOfferingPrice
}

// GetProductOfferingPriceOk returns a tuple with the ProductOfferingPrice field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetProductOfferingPriceOk() (*ProductOfferingPriceRef, bool) {
	if o == nil || o.ProductOfferingPrice == nil {
		return nil, false
	}
	return o.ProductOfferingPrice, true
}

// HasProductOfferingPrice returns a boolean if a field has been set.
func (o *PriceAlteration) HasProductOfferingPrice() bool {
	if o != nil && o.ProductOfferingPrice != nil {
		return true
	}

	return false
}

// SetProductOfferingPrice gets a reference to the given ProductOfferingPriceRef and assigns it to the ProductOfferingPrice field.
func (o *PriceAlteration) SetProductOfferingPrice(v ProductOfferingPriceRef) {
	o.ProductOfferingPrice = &v
}

// GetBaseType returns the BaseType field value if set, zero value otherwise.
func (o *PriceAlteration) GetBaseType() string {
	if o == nil || o.BaseType == nil {
		var ret string
		return ret
	}
	return *o.BaseType
}

// GetBaseTypeOk returns a tuple with the BaseType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetBaseTypeOk() (*string, bool) {
	if o == nil || o.BaseType == nil {
		return nil, false
	}
	return o.BaseType, true
}

// HasBaseType returns a boolean if a field has been set.
func (o *PriceAlteration) HasBaseType() bool {
	if o != nil && o.BaseType != nil {
		return true
	}

	return false
}

// SetBaseType gets a reference to the given string and assigns it to the BaseType field.
func (o *PriceAlteration) SetBaseType(v string) {
	o.BaseType = &v
}

// GetSchemaLocation returns the SchemaLocation field value if set, zero value otherwise.
func (o *PriceAlteration) GetSchemaLocation() string {
	if o == nil || o.SchemaLocation == nil {
		var ret string
		return ret
	}
	return *o.SchemaLocation
}

// GetSchemaLocationOk returns a tuple with the SchemaLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetSchemaLocationOk() (*string, bool) {
	if o == nil || o.SchemaLocation == nil {
		return nil, false
	}
	return o.SchemaLocation, true
}

// HasSchemaLocation returns a boolean if a field has been set.
func (o *PriceAlteration) HasSchemaLocation() bool {
	if o != nil && o.SchemaLocation != nil {
		return true
	}

	return false
}

// SetSchemaLocation gets a reference to the given string and assigns it to the SchemaLocation field.
func (o *PriceAlteration) SetSchemaLocation(v string) {
	o.SchemaLocation = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *PriceAlteration) GetType() string {
	if o == nil || o.Type == nil {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PriceAlteration) GetTypeOk() (*string, bool) {
	if o == nil || o.Type == nil {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *PriceAlteration) HasType() bool {
	if o != nil && o.Type != nil {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *PriceAlteration) SetType(v string) {
	o.Type = &v
}

func (o PriceAlteration) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.ApplicationDuration != nil {
		toSerialize["applicationDuration"] = o.ApplicationDuration
	}
	if o.Description != nil {
		toSerialize["description"] = o.Description
	}
	if o.Name != nil {
		toSerialize["name"] = o.Name
	}
	if true {
		toSerialize["priceType"] = o.PriceType
	}
	if o.Priority != nil {
		toSerialize["priority"] = o.Priority
	}
	if o.RecurringChargePeriod != nil {
		toSerialize["recurringChargePeriod"] = o.RecurringChargePeriod
	}
	if o.UnitOfMeasure != nil {
		toSerialize["unitOfMeasure"] = o.UnitOfMeasure
	}
	if true {
		toSerialize["price"] = o.Price
	}
	if o.ProductOfferingPrice != nil {
		toSerialize["productOfferingPrice"] = o.ProductOfferingPrice
	}
	if o.BaseType != nil {
		toSerialize["@baseType"] = o.BaseType
	}
	if o.SchemaLocation != nil {
		toSerialize["@schemaLocation"] = o.SchemaLocation
	}
	if o.Type != nil {
		toSerialize["@type"] = o.Type
	}
	return json.Marshal(toSerialize)
}

type NullablePriceAlteration struct {
	value *PriceAlteration
	isSet bool
}

func (v NullablePriceAlteration) Get() *PriceAlteration {
	return v.value
}

func (v *NullablePriceAlteration) Set(val *PriceAlteration) {
	v.value = val
	v.isSet = true
}

func (v NullablePriceAlteration) IsSet() bool {
	return v.isSet
}

func (v *NullablePriceAlteration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePriceAlteration(val *PriceAlteration) *NullablePriceAlteration {
	return &NullablePriceAlteration{value: val, isSet: true}
}

func (v NullablePriceAlteration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePriceAlteration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


